\documentclass{article}

%include lhs2TeX.fmt
%include lhs2TeX.sty

\DeclareMathAlphabet{\mathkw}{OT1}{cmss}{bx}{n}
%subst keyword a = "\mathkw{" a "}"
%subst conid a = "\mathsf{" a "}"

%format <-  = "\leftarrow "
%format :-> = "\arrow "
%format <>< = "<\!>\!< "
%format <><| = "<\!>\!<\!\!|\, "
%format <>> = "<\!>\!> "
%format <+> = "\oplus "
%format <*> = "\varoast "
%format <$> = "<\!\!\$\!\!> "
%format :$  = ":\!\!\$\ "
%format ::: = "\asc "
%format >=> = "\genarrow "
%format <?  = "\in "
%format ... = "\ldots "
%format >-  = "\Yright "
%format .   = "\,\circ\, "
%format +~  = "\,\widehat{+}\, "
%format -~  = "\,\widehat{-}\, "
%format *=  = "=_{\tiny \mathsf{TY}} "
%format #=  = "=_{\tiny \mathsf{GR}} "

%format F0  = "\emptycontext"
%format B0  = "\emptycontext"

%format LetGoal = "\letGoal "

%format Hole = "? "
%format Some = "!\!"

%format alpha  = "\alpha"
%format alpha0
%format alpha1
%format alpha'
%format alphaD = "\alpha\!D"
%format beta   = "\beta"
%format beta0
%format beta1
%format gamma  = "\gamma"
%format _Gamma  = "\Gamma"
%format _Gamma0
%format _Gamma1
%format delta  = "\delta"
%format delta0
%format delta1
%format nu     = "\nu"
%format sigma  = "\sigma"
%format sigma0
%format sigma1
%format sigma'
%format tau    = "\tau"
%format tau0
%format tau1
%format tau'
%format rho = "\rho"
%format upsilon = "\upsilon"
%format upsilon'
%format upsilon0
%format upsilon1
%format chi = "\chi"
%format _Xi = "\Xi"
%format _Xi0
%format _Xi1
%format _Psi = "\Psi"

\newcommand{\ident}[1]{\mathsf{#1}}
%subst varid a       = "\ident{ " a " }"
%format a   = "\mathit{a} "
%format d   = "\mathit{d} "
%format e   = "\mathit{e} "
%format f   = "\mathit{f} "
%format ma  = "\mathit{ma} "
%format s   = "\mathit{s} "
%format t   = "\mathit{t} "
%format w   = "\mathit{w} "
%format x   = "\mathit{x} "
%format xs  = "\mathit{xs} "
%format ys  = "\mathit{ys} "


\usepackage{a4wide}


% Boxes and inference rules
\newcommand{\mathframe}[1]{\framebox{\ensuremath{#1}}}
\newcommand{\boxrule}[1]{\begin{center}\mathframe{#1}\end{center}}
\newcommand{\boxrules}[2]{\begin{center}\mathframe{#1}\quad\mathframe{#2}\end{center}}
\newcommand{\boxruless}[3]{\begin{center}\mathframe{#1}\quad\mathframe{#2}\quad\mathframe{#3}\end{center}}
\newcommand{\name}[1]{\textsc{#1}}
\newcommand{\namer}[1]{\ensuremath{\mathrm{\name{#1}} \;}}
\newcommand{\side}[1]{\ensuremath{\; #1}}
\newcommand{\br}[2]{\genfrac{}{}{0pt}{0}{#1}{#2}}
\newcommand{\BigRule}[3]{\ensuremath{\Rule{\br{#1}{#2}}{#3}}}

% Text
\newcommand{\demph}[1]{\emph{#1}} % definitional emphasis
\newcommand{\remph}[1]{\emph{#1}} % rhetorical emphasis
\newcommand{\scare}[1]{`#1'}
\newcommand{\W}{\ensuremath{\mathcal{W}}}
\newcommand{\AlgorithmW}{Algorithm~\W}
\newcommand{\hindleymilner}{Hindley-Milner}
\newcommand{\hindleymilnershort}{HM}

% Definitions
\newcommand{\defmap}{~\mapsto~}
\newcommand{\centcolon}{\mathrel{\mathop:}}
\newcommand{\defsyn}{\centcolon\centcolon=}

% Substitutions
\newcommand{\eqsubst}{\equiv}
\newcommand{\compose}{\cdot}
\newcommand{\subst}[3]{[#1/#2]#3}
\newcommand{\restrict}[2]{#1 ||_{#2}}
\newcommand{\invsubs}[1]{#1^{-1}}

% Sets and sorts
\newcommand{\V}{\mathcal{V}}
\newcommand{\D}{\mathcal{D}}
\newcommand{\Ss}{\mathcal{S}}
\newcommand{\K}{\mathcal{K}}
\newcommand{\T}{\mathcal{T}}

% Context bits
\newcommand{\entails}{\ensuremath{\vdash}}
\newcommand{\notentails}{\ensuremath{\nvdash}}
% \newcommand{\entailsN}{\ensuremath{\Vdash}}
\newcommand{\emptycontext}{\ensuremath{\mathcal{E}}}
\newcommand{\letGoal}{\ensuremath{\fatsemi}}
\newcommand{\defn}{\ensuremath{\!\centcolon=\!}}
\newcommand{\asc}{\ensuremath{\!::\!}}
\newcommand{\hole}[1]{\ensuremath{#1 \!\centcolon= ?}}
\newcommand{\decl}[2]{#1 #2}

% Statements
\newcommand{\type}{\ensuremath{~\mathbf{type}}}
\newcommand{\scheme}{\ensuremath{~\mathbf{scheme}}}
\newcommand{\valid}{\ensuremath{\mathbf{valid}}}
\newcommand{\Sbind}[2]{#1 \Yright #2}
\newcommand{\hasscheme}{\ensuremath{::}}
\newcommand{\Pinf}[2]{#1 : #2}
\newcommand{\Psch}[2]{#1 \hasscheme #2}
\newcommand{\Puni}[2]{#1 \equiv #2}
\newcommand{\sanity}{sanity condition}
\newcommand{\Sanity}{Sanity condition}

% Types, terms and schemes
\newcommand{\arrow}{\ensuremath{\triangleright}}
\newcommand{\letIn}[3]{\ensuremath{\mathrm{let}\; #1 \!\centcolon=\! #2 \;\mathrm{in}\; #3}}
\newcommand{\letS}[3]{\ensuremath{(!#1 \!\centcolon=\! #2 ~\mathrm{in}~ #3)}}
\newcommand{\genarrow}{\ensuremath{\Uparrow}}
\newcommand{\gen}[2]{\ensuremath{(#1 \genarrow #2)}}
\newcommand{\gendot}[1]{\ensuremath{.{#1}}}

% Maps
\newcommand{\sem}[1]{\ensuremath{\llbracket #1 \rrbracket}}
\newcommand{\ok}{\ensuremath{\mathbf{ok}}}
\newcommand{\forget}[1]{\ensuremath{\lfloor #1 \rfloor}}
\newcommand{\semidrop}{\downharpoonright}

% Relations between contexts
\newcommand{\lei}{\ensuremath{\preceq}}
\newcommand{\LEI}{\ensuremath{~\hat\lei~}}
\newcommand{\leiR}{\ensuremath{\sqsubseteq}}
\newcommand{\LEIR}{\ensuremath{~\hat\sqsubseteq~}}
\newcommand{\transto}{\ensuremath{\twoheadrightarrow}}

\newcommand{\iRel}[4]{#1 #3 #4 \entails #2}
\newcommand{\ioRel}[5]{#1 \circ #2 #3 #4 \bullet #5}

\newcommand{\leiStmt}[3]{\iRel{#1}{#2}{\lei}{#3}}
\newcommand{\leiRStmt}[3]{\iRel{#1}{#2}{\leiR}{#3}}
\newcommand{\LEIStmt}[3]{\iRel{#1}{#2}{\LEI}{#3}}
\newcommand{\LEIRStmt}[3]{\iRel{#1}{#2}{\LEIR}{#3}}
\newcommand{\leiRParam}[4]{(#1, #2) \leiR (#3, #4)}
\newcommand{\LEIProb}[4]{\ioRel{#1}{#2}{\LEI}{#3}{#4}}
\newcommand{\LEIRProb}[4]{\ioRel{#1}{#2}{\LEIR}{#3}{#4}}
\newcommand{\LEIUnify}[4]{\LEIStmt{#1}{#2 \equiv #3}{#4}}
\newcommand{\LEIRUnify}[4]{\LEIRStmt{#1}{#2 \equiv #3}{#4}}
\newcommand{\LEIInfer}[4]{\LEIProb{#1}{(#2 :)}{#4}{#3}}
\newcommand{\LEIRInfer}[4]{\LEIRProb{#1}{(#2 :)}{#4}{#3}}
\newcommand{\LEIInferScheme}[4]{\LEIProb{#1}{(#2 \hasscheme)}{#4}{#3}}
\newcommand{\LEIRInferScheme}[4]{\LEIRProb{#1}{(#2 \hasscheme)}{#4}{#3}}

\newcommand{\alg}[4]{\ioRel{#1}{#2}{\transto}{#3}{#4}}
\newcommand{\ialg}[3]{\iRel{#1}{#2}{\transto}{#3}}
\newcommand{\algUnify}[4]{\ialg{#1}{#2 \equiv #3}{#4}}
\newcommand{\algInstantiate}[5]{\ialg{#1 ~||~ #4}{#2 \equiv #3}{#5}}
\newcommand{\algUnifyVecDim}[4]{\ialg{#1}{#2 \equivAG #3}{#4}}
\newcommand{\algUnifyDim}[4]{\ialg{#1, [#2]}{\equivunit{#3}}{#4}}
\newcommand{\algInfer}[4]{\alg{#1}{(#2 :)}{#4}{#3}}
\newcommand{\algInferScheme}[4]{\alg{#1}{(#2 \hasscheme)}{#4}{#3}}

% Problem bits
\newcommand{\iprobcond}[2]{#1\! [#2]}
\newcommand{\iprobstmt}[3]{#1\! [#2]\, #3}
\newcommand{\iprobsubst}[4]{(#1 (#2\! [#3]))\, #4}
\newcommand{\probstmt}[2]{#1 #2}
\newcommand{\probsubst}[3]{(#1 #2) #3}

\newcommand{\leParam}[4]{#2 \entails #3 \subset_{#1} #4}
\newcommand{\pconj}[3]{\Sigma #1 #3}
\newcommand{\Qbind}[2]{#1 ~ \Yright #2}


% Additive and multiplicative notation
\newcommand{\amn}[2]{}
\newcommand{\AdditiveNotation}{\renewcommand{\amn}[2]{##1}}
\newcommand{\MultiplicativeNotation}{\renewcommand{\amn}[2]{##2}}
\AdditiveNotation

% Basic group operations
\newcommand{\unit}{\amn{0}{1}}
\newcommand{\inv}[1]{\amn{\mathop{-}\!#1}{{#1}^{-1}}}
\newcommand{\pow}[2]{\amn{#2 #1}{{#1}^{#2}}}
\newcommand{\mulop}{\amn{+}{}}
\newcommand{\mul}[2]{#1 \mulop #2}
\newcommand{\mulinv}[2]{\amn{#1 - #2}{\mul{#1}{\inv{#2}}}}

% Derived operations
% \newcommand{\mulpow}[5]{\amn{\sum_{#1 = #2}^{#3} #4 #5}{\prod_{#1 = #2}^{#3} \pow{#5}{#4}}}
\newcommand{\mulpow}[5]{\amn{\sum_{#1} #4 #5}{\prod_{#1} \pow{#5}{#4}}}
\newcommand{\normalform}[4]{\mulpow{#1}{0}{#2}{{#3}_{#1}}{{#4}_{#1}}}
\newcommand{\quotPowers}[2]{Q_{#2}(#1)}
\newcommand{\remPowers}[2]{R_{#2}(#1)}

% Number theory
\newcommand{\quot}[2]{#1 \mathop{\mathrm{quot}} #2}
\newcommand{\rem}[2]{#1 \mathop{\mathrm{rem}} #2}
\newcommand{\divides}{ \mid }
\newcommand{\notdivides} { \nmid }
\newcommand{\abs}[1]{|| #1 ||}

% Terms with dimensions, etc.
\newcommand{\maxpow}[1]{\mathrm{\amn{maxc}{maxpow}(#1)}}
\newcommand{\F}[1]{\mathbb{F} \langle #1 \rangle}
\newcommand{\pair}[2]{(#1, #2)}
\newcommand{\hull}[2]{#1 [ #2 ]}
\newcommand{\hullD}[2]{(\hull{#1}{#2})}
\newcommand{\basedim}[1]{\mathbf{#1}}
\newcommand{\equivunit}[1]{#1 ~\mathbf{id}}

% Text substitutions
\newcommand{\Fsharp}{F\#}
\newcommand{\power}{\amn{coefficient}{power}}
\newcommand{\powers}{\power{s}}
\newcommand{\multiplicative}{\amn{additive}{multiplicative}}
\newcommand{\naive}{na\"{\i}ve}


\newcommand{\Sub}[1]{\mathrm{#1}}
\newcommand{\SubStyle}{\scriptscriptstyle}
\newcommand{\expSub}[2]{#2 \equivSub{#1} #2}
\newcommand{\equivSub}[1]{\equiv_{\SubStyle #1}}
\newcommand{\semSub}[2]{\sem{#2}_{\SubStyle #1}}
\newcommand{\okSub}[1]{\ok_{\SubStyle #1}}
\newcommand{\VarsSub}[1]{\V_{\SubStyle #1}}
\newcommand{\fvSub}[1]{\mathit{FV}_{\SubStyle #1}}

\newcommand{\AG}{\Sub{GE}}
\newcommand{\expAG}[1]{\expSub{\AG}{#1}}
\newcommand{\equivAG}{\equivSub{\AG}}
\newcommand{\semAG}[1]{\semSub{\AG}{#1}}
\newcommand{\okAG}{\okSub{\AG}}
\newcommand{\VarsAG}{\VarsSub{\AG}}
\newcommand{\VarsAGof}[1]{\VarsAG(#1)}
\newcommand{\fvAG}[1]{\fvSub{\AG}(#1)}

\newcommand{\expT}[1]{\expSub{T}{#1}}
\newcommand{\equivT}{\equivSub{T}}
\newcommand{\semT}[1]{\semSub{T}{#1}}
\newcommand{\okT}{\okSub{T}}
\newcommand{\VarsT}{\VarsSub{T}}
\newcommand{\VarsTof}[1]{\VarsT(#1)}
\newcommand{\fvT}[1]{\fvSub{T}(#1)}

\newcommand{\semK}[1]{\semSub{K}{#1}}
\newcommand{\okK}{\okSub{K}}
\newcommand{\VarsK}{\VarsSub{K}}
\newcommand{\VarsKof}[1]{\VarsK(#1)}
\newcommand{\fvK}[1]{\fvSub{K}(#1)}

\newcommand{\TY}{\Sub{TY}}
\newcommand{\expTY}[1]{\expSub{\TY}{#1}}
\newcommand{\equivTY}{\equivSub{\TY}}
\newcommand{\semTY}[1]{\semSub{\TY}{#1}}
\newcommand{\okTY}{\okSub{\TY}}
\newcommand{\VarsTY}{\VarsSub{\TY}}
\newcommand{\VarsTYof}[1]{\VarsTY(#1)}
\newcommand{\fvTY}[1]{\fvSub{\TY}(#1)}

\newcommand{\TM}{\mathrm{\textsc{TM}}}
\newcommand{\semTM}[1]{\semSub{\TM}{#1}}
\newcommand{\okTM}{\okSub{\TM}}
\newcommand{\VarsTM}{\VarsSub{\TM}}


\newcommand{\SolvePrime}{Solve$^\prime$}
\newcommand{\DependSPrime}{DependS$^\prime$}

\newcommand{\widevec}[1]{\overrightarrow{#1}}

\setlength{\parskip}{5pt}
\setlength{\parindent}{0pt}

\title{Type Inference for Units of Measure: Implementation}
\author{Adam Gundry}
\date{2nd February 2011}

\begin{document}

\maketitle

%include Basics.lhs
%include Group.lhs
%include Context.lhs
%include GroupUnify.lhs
%include Unify.lhs
%include Inference.lhs


\section{Main}

> module Main where

> import Prelude hiding (any)
> import Control.Monad.Error ()
> import Control.Monad.State (StateT, runStateT)

> import Basics
> import Group
> import Context
> import Unify
> import Inference

The |findTY| and |findGE| functions look up a variable of a particular
sort in the context, and return its declaration.

> findTY :: Context -> TyName -> Maybe Type
> findTY B0                    _           = error "findTY: missing!"
> findTY (_ :< A (y := TY o))  x | x == y  = o
> findTY (c :< _)              x           = findTY c x

> findGE :: Context -> TyName -> Maybe Dimension
> findGE B0                    _           = error "findGE: missing!"
> findGE (_ :< A (y := GE o))  x | x == y  = o
> findGE (c :< _)              x           = findGE c x


The |normalise| function returns the normal form (i.e.\ with all type
variables expanded as far as possible) of the given type within the
given context.

> normalise :: Context -> Type -> Type
> normalise _Gamma tau = normalStep (normaliseContext B0 (_Gamma <>> F0)) tau
>     where
>         normalStep :: Context -> Type -> Type
>         normalStep c (s :-> t) = normalStep c s :-> normalStep c t
>         normalStep c (Float d) = Float (normalDim c d [])
>         normalStep c (V x) = case findTY c x of
>                                  Nothing    -> V x
>                                  Just t  -> t
>
>         normalDim :: Context -> Dimension -> [TyName] -> Dimension
>         normalDim c d ws = case findVariable (flip notElem ws . fst) d of
>             Just (v, n) -> case findGE c v of
>                                Just e  -> normalDim c (substGExp (v, n) e d) ws
>                                Nothing    -> normalDim c d (v:ws)
>             Nothing -> d
>
>         normaliseContext :: Context -> Fwd Entry -> Context
>         normaliseContext c F0 = c
>         normaliseContext c (A (x := TY (Just t)) :> es) = 
>             normaliseContext (c :< A (x := TY (Just (normalStep c t)))) es
>         normaliseContext c (A (x := GE (Just t)) :> es) = 
>             normaliseContext (c :< A (x := GE (Just (normalDim c t [])))) es
>         normaliseContext c (e :> es) = normaliseContext (c :< e) es


We implement a bunch of unit tests, which allow the algorithms to be
tested with

> main :: IO ()
> main = mapM_ putStrLn $
>     map unifyTest unifyTests
>     ++ map (inferTest . ins B0) inferTests
>     ++ map (inferTest . ins floatContext) inferFloatTests
>   where ins c (a, b) = (a, b, c)

Note that equality of normalised types is syntactic (it does not
perform renaming) so changing the algorithm may sometimes cause
spurious failures as the fresh variable numbers may be different.

> unifyTest :: (Type, Type, Context, Maybe Context) -> String
> unifyTest (sigma, tau, c0, mc) = case runStateT (unify sigma tau) (0, c0) of
>     Right ((), (_, c1))
>         | Just c1 == mc  -> "OKAY"
>         | otherwise      -> "FAIL: " ++ show sigma ++ " == " 
>                                 ++ show tau ++ " in " ++ show c1
>     Left s
>         | mc == Nothing  -> "OKAY (" ++ s ++ ")"
>         | otherwise      -> "FAIL (" ++ s ++ ") " ++ show sigma ++ " /= " ++ show tau

> inferTest :: (Term, Maybe Type, Context) -> String
> inferTest (t, expected, gamma) = case runStateT (infer t) (0, gamma) of
>     Right (tau, (_, c))
>         | Just tau' == expected  -> "OKAY"
>         | otherwise              -> "FAIL: " ++ show t ++ " in " ++ show c
>                                         ++ "has type " ++ show tau'
>                                         ++ " /= " ++ show expected
>       where tau' = normalise c tau
>     Left s
>         | expected == Nothing  -> "OKAY (" ++ s ++ ")"
>         | otherwise            -> "FAIL (" ++ s ++ "): " ++ show t
>                                       ++ " should type to " ++ show expected




> (*=) :: TyName -> Maybe Type -> Entry
> alpha *= d = A (alpha := TY d)

> (#=) :: TyName -> Maybe Dimension -> Entry
> alpha #= d = A (alpha := GE d)

> unifyTests :: [(Type, Type, Context, Maybe Context)]
> unifyTests = [
>     (V 0, V 1,
>         B0 :< 0 *= Nothing :< 1 *= Nothing,
>         Just (B0 :< 0 *= Nothing :< 1 *= Just (V 0))),
>     (V 0, V 1 :-> V 2, 
>         B0 :< 0 *= Nothing :< 1 *= Nothing :< 2 *= Nothing,
>         Just (B0 :< 1 *= Nothing :< 2 *= Nothing :< 0 *= Just (V 1 :-> V 2))),
>     (V 0, V 1 :-> V 2,
>         B0 :< 0 *= Nothing :< 2 *= Just (V 0) :< 1 *= Just (V 0),
>         Nothing),
>     (V 0 :-> V 0, V 1 :-> V 1,
>         B0 :< 1 *= Nothing :< 0 *= Nothing,
>         Just (B0 :< 1 *= Nothing :< 0 *= Just (V 1))),
>     (V 0, V 1 :-> V 2,
>        B0 :< 1 *= Nothing :< 0 *= Just (V 1 :-> V 1) :< 2 *= Nothing,
>        Just (B0 :< 1 *= Nothing :< 2 *= Just (V 1) :< 0 *= Just (V 1 :-> V 1))),
>     (V 0 :-> V 1, V 1 :-> V 0,
>        B0 :< 0 *= Nothing :< 1 *= Nothing,
>        Just (B0 :< 0 *= Nothing :< 1 *= Just (V 0))),
>     (V 0 :-> V 1 :-> V 2, V 1 :-> V 0 :-> V 0,
>        B0 :< 2 *= Nothing :< 0 *= Nothing :< 1 *= Nothing,
>        Just (B0 :< 2 *= Nothing :< 0 *= Just (V 2) :< 1 *= Just (V 0))),
>     (Float (mkGExp [] []), Float (mkGExp [] []),
>         B0,
>         Just B0),
>     (Float (mkGExp [] [(SEC, 1)]), Float (mkGExp [] [(SEC, 1)]),
>         B0,
>         Just B0),
>     (Float (mkGExp [] [(SEC, 1)]), Float (mkGExp [] []),
>         B0,
>         Nothing),
>     (Float (mkGExp [(45, 1)] []), Float (mkGExp [(45, 1)] []),
>         B0 :< 45 #= Nothing,
>         Just (B0 :< 45 #= Nothing)),
>     (Float (mkGExp [(45, 1)] []), Float (mkGExp [] [(SEC, 2)]),
>         B0 :< 45 #= Nothing,
>         Just (B0 :< 45 #= Just (mkGExp [] [(SEC, 2)]))),
>     (Float (mkGExp [(45, 1)] [(SEC, 3)]), Float (mkGExp [] [(SEC, 2)]),
>         B0 :< (45 #= Nothing),
>         Just (B0 :< (45 #= Just (mkGExp [] [(SEC, -1)])))),
>     (Float (mkGExp [(45, 1)] [(KG, -1), (SEC, 3)]), Float (mkGExp [] [(SEC, 2)]),
>         B0 :< (45 #= Nothing),
>         Just (B0 :< (45 #= Just (mkGExp [] [(SEC, -1), (KG, 1)])))),
>     (Float (mkGExp [(45, 1)] []), Float (mkGExp [] []),
>         B0 :< (45 #= Nothing),
>         Just (B0 :< (45 #= Just (mkGExp [] [])))),
>     (Float (mkGExp [(45, 2)] []), Float (mkGExp [] [(METRE, 2)]),
>         B0 :< (45 #= Nothing),
>         Just (B0 :< (45 #= Just (mkGExp [] [(METRE, 1)])))),
>     (Float (mkGExp [(45, 2)] [(SEC, 4), (KG, 6)]), Float (mkGExp [] [(METRE, 2)]),
>         B0 :< (45 #= Nothing),
>         Just (B0 :< (45 #= Just (mkGExp [] [(METRE, 1), (KG, -3), (SEC, -2)])))),
>     (Float (mkGExp [(45, 2)] [(SEC, 1)]), Float (mkGExp [] []),
>         B0 :< (45 #= Nothing),
>         Nothing),
>     (Float (mkGExp [(45, 1), (46, 1)] []), Float (mkGExp [(46, 2)] []),
>         B0 :< (45 #= Nothing) :< (46 #= Nothing),
>         Just (B0 :< (45 #= Nothing) :< (46 #= Just (mkGExp [(45, 1)] [])))),
>     (Float (mkGExp [(45, 1)] []), Float (mkGExp [] [(METRE, 1), (SEC, -2)]),
>         B0 :< (45 #= Just (mkGExp [] [(SEC, -2), (METRE, 1)])),
>         Just (B0 :< (45 #= Just (mkGExp [] [(SEC, -2), (METRE, 1)])))),
>     (Float (mkGExp [(45, 1), (46, 2)] []), Float (mkGExp [] []),
>         B0 :< (45 #= Nothing) :< (46 #= Nothing),
>         Just (B0 :< (46 #= Nothing) :< (45 #= Just (mkGExp [(46, -2)] [])))),
>     (Float (mkGExp [(45, 2), (46, 3)] []), Float (mkGExp [] []),
>         B0 :< (45 #= Nothing) :< (46 #= Nothing),
>         Just (B0 :< (0 #= Nothing) :< (46 #= Just (mkGExp [(0, -2)] [])) :< (45 #= Just (mkGExp [(0, 1), (46, -1)] [])))),
>     (Float (mkGExp [(45, 2), (46, 3)] [(KG, 6)]), Float (mkGExp [] []),
>         B0 :< (45 #= Nothing) :< (46 #= Nothing),
>         Just (B0 :< (0 #= Nothing) :< (46 #= Just (mkGExp [(0, -2)] [])) :< (45 #= Just (mkGExp [(0, 1), (46, -1)] [(KG, -3)])))),
>     (Float (mkGExp [(45, 1)] [(SEC, 1)]), Float (mkGExp [] []),
>         B0 :< (45 #= Just (mkGExp [] [(SEC, -1)])),
>         Just (B0 :< (45 #= Just (mkGExp [] [(SEC, -1)])))),
>     (Float (mkGExp [(45, 1), (46, 2)] []), Float (mkGExp [] []),
>         B0 :< (45 #= Nothing) :< (46 #= Just (mkGExp [] [(SEC, 1)])),
>         Just (B0 :< (45 #= Just (mkGExp [] [(SEC, -2)])) :< (46 #= Just (mkGExp [] [(SEC, 1)])))),
>     (Float (mkGExp [(45, 2), (46, 1)] []), Float (mkGExp [] []),
>         B0 :< (45 #= Nothing) :< (46 #= Just (mkGExp [] [(SEC, 1)])),
>         Nothing),
>     (Float (mkGExp [(45, 2), (46, 1)] []), Float (mkGExp [] []),
>         B0 :< (45 #= Nothing) :< (46 #= Just (mkGExp [] [(SEC, 2)])),
>         Just (B0 :< (45 #= Just (mkGExp [] [(SEC, -1)])) :< (46 #= Just (mkGExp [] [(SEC, 2)])))),
>     (Float (mkGExp [(45, 3), (47, 2)] []), Float (mkGExp [] []),
>         B0 :< (45 #= Nothing) :< (46 #= Nothing) :< (47 #= Just (mkGExp [(46, 1)] [])),
>         Just (B0 :< (0 #= Nothing) :< (45 #= Just (mkGExp [(0,-2)] [])) :< (46 #= Just (mkGExp [(45,-1),(0,1)] [])) :< (47 #= Just (mkGExp [(46,1)] [])))),
>     (Float (mkGExp [(45, 1), (47, 2)] []), Float (mkGExp [] []),
>         B0 :< (45 #= Nothing) :< (46 #= Nothing) :< (47 #= Just (mkGExp [(46, 1)] [])),
>         Just (B0 :< (46 #= Nothing) :< (45 #= Just (mkGExp [(46, -2)] [])) :< (47 #= Just (mkGExp [(46, 1)] [])))),
>     (Float (mkGExp [(45, 1), (46, 2)] []), Float (mkGExp [] []),
>         B0 :< (45 #= Nothing) :< (46 #= Just (mkGExp [(45, 1)] [])),
>         Just (B0 :< (45 #= Just (mkGExp [] [])) :< (46 #= Just (mkGExp [(45, 1)] [])))),
>     (Float (mkGExp [(45, 1), (46, 2), (47, 3)] []), Float (mkGExp [] []),
>         B0 :< (45 #= Nothing) :< (46 #= Nothing) :< (47 #= Nothing),
>         Just (B0 :< (45 #= Nothing) :< (0 #= Nothing) :< (47 #= Just (mkGExp [(45, -1), (0, -2)] [])) :< (46 #= Just (mkGExp [(0, 1), (47, -1)] [])))),
>     (Float (mkGExp [(45, 1), (46, 2), (47, 2)] []), Float (mkGExp [] []),
>         B0 :< (45 #= Nothing) :< (46 #= Nothing) :< (47 #= Nothing),
>         Just (B0 :< (0 #= Nothing) :< (45 #= Just (mkGExp [(0, -2)] [])) :< (46 #= Nothing) :< (47 #= Just (mkGExp [(0, 1), (46, -1)] [])))),
>     (Float (mkGExp [] []), (Float (mkGExp [] []) :-> Float (mkGExp [] [])),
>         B0,
>         Nothing),
>     (Float (mkGExp [(45, 1), (46, -3)] []), Float (mkGExp [] []),
>         B0 :< (45 #= Nothing) :< (46 #= Nothing),
>         Just (B0 :< (46 #= Nothing) :< (45 #= Just (mkGExp [(46, 3)] [])))),
>     (V 1000, V 1001 :-> V 1001, 
>         B0 :< 1000 *= Nothing :< LetGoal :< (42 #= Nothing) :< (43 #= Nothing)
>              :< 1001 *= Just (Float (mkGExp [(42, 1), (43, 1)] [])),
>         Just (B0 :< 0 #= Nothing :< 1001 *= (Just (Float (mkGExp [(0,1)] []))) :< 1000 *= (Just (V 1001 :-> V 1001)) :< LetGoal :< 42 #= Nothing :< 43 #= (Just (mkGExp [(0,1),(42,-1)] [])))),
>     (V 1000, Float (mkGExp [(42, 1)] []),
>         B0 :< 1000 *= Nothing :< LetGoal :< (43 #= Nothing) :< (44 #= Nothing) :< (42 #= Just (mkGExp [(43, 1), (44, 1)] [])),
>         Just (B0 :< 0 #= Nothing :< 1000 *= (Just (Float (mkGExp [(0,1)] []))) :< LetGoal :< 43 #= Nothing :< 44 #= (Just (mkGExp [(43,-1),(0,1)] [])) :< 42 #= (Just (mkGExp [(44,1),(43,1)] []))))
>     ]



> inferTests :: [(Term, Maybe Type)]
> inferTests = [
>     (X "u", 
>          Nothing),
>     (Lam "x" (X "x"),
>          Just (V 0 :-> V 0)),
>     (Lam "x" (X "x" :$ X "x"),
>          Nothing),
>     (Lam "x" (Lam "y" (X "y")),
>          Just (V 0 :-> V 1 :-> V 1)),
>     (Lam "x" (Lam "y" (X "x")),
>          Just (V 0 :-> V 1 :-> V 0)),
>     (Lam "x" (Lam "y" (X "y") :$ X "x"),
>          Just (V 0 :-> V 0)),
>     (Lam "x" (Lam "y" (X "x") :$ X "x"),
>          Just (V 0 :-> V 0)),
>     (Let "m" (Lam "a" (X "a")) (X "m" :$ X "m"),
>          Just (V 2 :-> V 2)),
>     (Let "s" (Let "m" (Lam "a" (X "a")) (X "m" :$ X "m")) (X "s"), 
>          Just (V 4 :-> V 4)),
>     (Lam "x" (Lam "y" (X "x")),
>          Just (V 0 :-> (V 1 :-> V 0))),
>     (Lam "x" (Lam "y" (X "x" :$ X "y")),
>          Just ((V 1 :-> V 2) :-> (V 1 :-> V 2))),
>     (Let "I" (Lam "x" (X "x")) (X "I"),
>          Just (V 1 :-> V 1))
>   ]

> floatContext :: Context
> floatContext = B0
>   :< T ("zero"   ::: Bind (GE Nothing) (Type (Float (mkGExp [(Z, 1)] []))))
>   :< T ("one"    ::: Type (Float (mkGExp [] [])))
>   :< T ("mass"   ::: Type (Float (mkGExp [] [(KG, 1)])))
>   :< T ("time"   ::: Type (Float (mkGExp [] [(SEC, 1)])))
>   :< T ("times"  ::: Bind (GE Nothing) (Bind (GE Nothing) (Type (Float (mkGExp [(S Z, 1)] []) :-> Float (mkGExp [(Z, 1)] []) :-> Float (mkGExp [(S Z, 1), (Z, 1)] [])))))
>   :< T ("plus"   ::: Bind (GE Nothing) (Type (Float (mkGExp [(Z, 1)] []) :-> Float (mkGExp [(Z, 1)] []) :-> Float (mkGExp [(Z, 1)] []))))
>   :< T ("sect"   ::: Type (Float (mkGExp [] [(SEC, 2)]) :-> Float (mkGExp [] [(SEC, 3)])))
>   :< T ("div"    ::: Bind (GE Nothing) (Bind (GE Nothing) (Type (Float (mkGExp [(Z, 1), (S Z, 1)] []) :-> Float (mkGExp [(S Z, 1)] []) :-> Float (mkGExp [(Z, 1)] [])))))
>   :< T ("pair"   ::: Bind (TY Nothing) (Bind (TY Nothing) (Type (V (S Z) :-> V Z :-> V (S Z) :-> V Z))))

> inferFloatTests :: [(Term, Maybe Type)]
> inferFloatTests = [
>     (X "zero",
>        Just (Float (mkGExp [(0, 1)] []))),
>     (X "times" :$ X "mass" :$ X "mass",
>        Just (Float (mkGExp [] [(KG, 2)]))),
>     (X "times" :$ (X "sect" :$ X "zero") :$ X "mass",
>        Just (Float (mkGExp [] [(SEC, 3), (KG, 1)]))), 
>     (Lam "a" (Lam "b" (X "plus" :$ X "a" :$ X "b")),
>        Just (Float (mkGExp [(4, 1)] []) :-> Float (mkGExp [(4, 1)] []) :-> Float (mkGExp [(4, 1)] []))),
>     (Lam "x" (Let "d" (X "div" :$ X "x") (X "pair" :$ (X "d" :$ X "mass") :$ (X "d" :$ X "time"))),
>        Just (Float (mkGExp [(4, 1)] []) :-> Float (mkGExp [(4, 1)] [(KG, -1)]) :-> Float (mkGExp [(4, 1)] [(SEC, -1)]))),
>     (Let "recip" (X "div" :$ X "one") (X "pair" :$ (X "recip" :$ X "mass") :$ (X "recip" :$ X "time")),
>        Just (Float (mkGExp [] [(KG, -1)]) :-> Float (mkGExp [] [(SEC, -1)])))
>   ]


\end{document}